<!--
  @description: 报表统计-供应商统计-供应商投标项目详情
  @Modifier: 肖文龙
  @routerPath:
  @date: 2021-01-30
-->
<template>
  <el-dialog
    v-dialogDrag
    :modal="false"
    :visible.sync="dialog"
    :close-on-click-modal="false"
    title="详情"
    width="840px"
  >
    <section class="clearfix">
      <el-form ref="searchForm" :model="searchForm" inline>
        <el-form-item prop="tenderNo" label="项目编号">
          <el-input v-model="searchForm.tenderNo" />
        </el-form-item>
        <el-form-item class="fr">
          <el-button type="primary" round @click="search">
            查询
          </el-button>
          <el-button type="primary" round @click="resetForm('searchForm')">
            重置
          </el-button>
          <el-button type="primary" round @click="exportChange('')">
            导出
          </el-button>
        </el-form-item>
      </el-form>
    </section>
    <tableChart
      :height="height"
      class="echart-dom"
      :option="option"
    />
    <pagination :pagination-data="paginationData" @change="loadData" />
  </el-dialog>
</template>

<script>
/* api */
import { listTenderBySupplierIdPages, exportTenderBySupplierIdList } from '@api/statisticalAnalysis/reportChart.js'
/* 公用方法*/
import { download, filterObj, restoreInitialValue } from '@/assets/js/utils'// 过滤空的key
/* 混合开发方法-参数字段*/
import { ListMixin } from '@/mixins/ListMixin'// 分页
/* 組件 */
import tableChart from './../../components/tableChart'// table列表渲染组件
import pagination from '@comp/common/pagination/pagination'// 分页

export default {
  name: 'SupplierTenderDetail',
  components: {
    tableChart, // table列表渲染组件
    pagination // 分页
  },
  mixins: [ListMixin],
  data() {
    return {
      height: '450px', // 高度
      dialog: false, // 弹窗状态
      // 查询条件
      supplierId: '', // 供应商id
      supplierName: '', // 供应商名称
      searchForm: {
        tenderNo: '', // 项目编号
        supplierId: '' // 供应商id
      },
      // 全局的查询条件
      searchChartData: {
      },
      option: {
        // 非TOP排序
        showIndexTOP: false,
        // 标题
        thead: [
          { lable: '项目编号', prop: 'tenderNo', align: 'center' },
          { lable: '采购项目名称', prop: 'tenderName', align: 'left' },
          { lable: '采购单位', prop: 'buyerName', align: 'left' }
        ],
        // 渲染数据
        data: []
      }
    }
  },
  methods: {
    /**
     * 打开弹窗
     *  @param {row} Object 供应商信息
     *  @param {searchChartData} Object 全局的查询条件
    */
    open(row, searchChartData) {
      this.dialog = true
      this.supplierId = row.supplierId
      this.supplierName = row.supplierName
      this.searchChartData = searchChartData
      this.loadData()
    },
    // 获取数据
    loadData() {
      this.option.data = []
      const data = this.getParams()
      listTenderBySupplierIdPages(data).then(res => {
        this.paginationData.total = res.data.total
        this.option.data.push(...res.data.records)
      })
    },
    // 查询条件
    getParams() {
      this.searchForm = {
        ...this.searchForm,
        ...this.searchChartData
      }
      const param = Object.assign({}, this.searchForm)
      param.supplierId = this.supplierId
      param.pageNo = this.paginationData.pageNo
      param.pageSize = this.paginationData.pageSize
      return filterObj(param)// 过滤空的key
    },
    // 搜索
    search() {
      this.paginationData.pageNo = 1
      this.paginationData.pageSize = 10
      this.loadData()
    },
    // 重置
    resetForm(formName) {
      restoreInitialValue(this.searchForm)
      this.search()
    },
    // 导出
    exportChange() {
      const data = this.getParams()
      exportTenderBySupplierIdList(data).then(res => {
        download(res, this.supplierName + '投标项目信息详情表.xls')
      })
    }
  }
}
</script>

<style scoped lang="less">
</style>
